package com.fp.persistence.pgeneral.gene;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import com.fp.dto.hb.Cache;
import com.fp.dto.hb.HibernateBean;

/** Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENECATALOGDETAIL */
@Entity(name = "TgeneCatalogDetail")
@Table(name = "TGENECATALOGDETAIL")
public class TgeneCatalogDetail extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable, Cache {
    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;

    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;

    /**
     * Clave primaria de la Entidad TgeneCatalogDetail
     */
    @EmbeddedId
    private TgeneCatalogDetailKey pk;

    @Version
    @Column(name = "RECORDVERSION", nullable = true)
    /**
     * Optimistic locking del registro
     */
    private Integer recordversion;

    @Column(name = "DESCRIPTION", nullable = false)
    /**
     * Descripcion del catalogo 
     */
    private String description;

    @Column(name = "LEGALCODE", nullable = true)
    /**
     * Codigo del organismo de control
     */
    private String legalcode;

    /** Contructor por defecto */
    public TgeneCatalogDetail() {
    }

    /**
     * Contructor de TgeneCatalogDetail
     * 
     * @param pPk Clave Primaria del entity
     * @param pDescription Descripcion del catalogo
     */
    public TgeneCatalogDetail(TgeneCatalogDetailKey pPk, String pDescription) {
        this();
        pk = pPk;
        description = pDescription;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TgeneCatalogDetail
     */
    public static TgeneCatalogDetail find(EntityManager pEntityManager, TgeneCatalogDetailKey pKey) throws Exception {
        TgeneCatalogDetail obj = pEntityManager.find(TgeneCatalogDetail.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TgeneCatalogDetail
     * 
     * @return El objeto que referencia a la Clave primaria de TgeneCatalogDetail
     */
    public TgeneCatalogDetailKey getPk() {
        return pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TgeneCatalogDetail
     * 
     * @param pPk El objeto que referencia a la nueva Clave primaria de TgeneCatalogDetail
     */
    public void setPk(TgeneCatalogDetailKey pPk) {
        pk = pPk;
    }

    /**
     * Obtiene el valor de recordversion
     * 
     * @return valor de recordversion
     */
    public Integer getRecordversion() {
        return recordversion;
    }

    /**
     * Fija el valor de recordversion
     * 
     * @param pRecordversion nuevo Valor de recordversion
     */
    public void setRecordversion(Integer pRecordversion) {
        recordversion = pRecordversion;
    }

    /**
     * Obtiene el valor de description
     * 
     * @return valor de description
     */
    public String getDescription() {
        return description;
    }

    /**
     * Fija el valor de description
     * 
     * @param pDescription nuevo Valor de description
     */
    public void setDescription(String pDescription) {
        description = pDescription;
    }

    /**
     * Obtiene el valor de legalcode
     * 
     * @return valor de legalcode
     */
    public String getLegalcode() {
        return legalcode;
    }

    /**
     * Fija el valor de legalcode
     * 
     * @param pLegalcode nuevo Valor de legalcode
     */
    public void setLegalcode(String pLegalcode) {
        legalcode = pLegalcode;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TgeneCatalogDetail)) {
            return false;
        }
        TgeneCatalogDetail that = (TgeneCatalogDetail) rhs;
        if (getPk() == null || that.getPk() == null) {
            return false;
        }
        return getPk().equals(that.getPk());
    }

    /**
     * Implementación del metodo hashCode de la la entidad TgeneCatalogDetail
     * 
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (hashValue == 0) {
            int result = 17;
            if (getPk() == null) {
                result = super.hashCode();
            } else {
                result = getPk().hashCode();
            }
            hashValue = result;
        }
        return hashValue;
    }

    /** Implementación toString */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /** Implementación de la creación de un bean en blanco TgeneCatalogDetail */
    @Override
    public Object createInstance() {
        TgeneCatalogDetail instance = new TgeneCatalogDetail();
        instance.setPk(new TgeneCatalogDetailKey());
        return instance;
    }

    /**
     * Clona la entidad TgeneCatalogDetail
     * 
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TgeneCatalogDetail p = (TgeneCatalogDetail) clone();
        p.setPk((TgeneCatalogDetailKey) pk.cloneMe());
        return p;
    }

    /* Métodos manuales */

    /** Sentencia para seleccionar una lista de catalogos */
    private static final String JPQL_CATALOG_LIST = " from TgeneCatalogDetail t " + " where t.pk.catalogcode = :catalogcode ";

    /**
     * Método que selecciona una lista de catalogos dado el código del catalogo
     * 
     * @param entityManager
     * @param pCatalogcode Código del catalogo
     * @return
     * @throws Exception
     */
    @SuppressWarnings("unchecked")
    public static List<TgeneCatalogDetail> find(EntityManager entityManager, String pCatalogcode) throws Exception {
        Query qry = entityManager.createQuery(JPQL_CATALOG_LIST);
        qry.setParameter("catalogcode", pCatalogcode);

        return qry.getResultList();
    }

}
